using System;
using Microsoft.SPOT;
using GHIElectronics.NETMF.Net.Sockets;
using GHIElectronics.NETMF.Net;
using System.Text;



/*****************************************************************
 * The RTC class offers a functionality to obtain the current
 * date/time from the Internet.
 * ***************************************************************/
class RTC
{

    // constructor for the RTC class
    public RTC()
    {
    }



    public static DateTime GetNetworkTime()
    {

        //byte[] ip = { 195,130,132,18 };//time-a.nist.gov            

       /* Socket mySocket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
        IPAddress DestinationIP = new IPAddress(new byte[] { 195,130,132,18});
        IPEndPoint DestinationEndPoint = new IPEndPoint(DestinationIP, 123);
        */

        Socket mySocket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
        IPAddress DestinationIP = new IPAddress(new byte[] { 192,168,2,2 });
        IPEndPoint DestinationEndPoint = new IPEndPoint(DestinationIP, 130);
        IPEndPoint MyServiceEndPoint = new IPEndPoint(IPAddress.Any, 0);
        String msg = "Hello PC";



        byte[] bytesToSend = Encoding.UTF8.GetBytes(msg);
        while (true)
        {

            Debug.Print("sending ....");
            byte[] ntpDataSend = new byte[48]; // RFC 2030
            ntpDataSend[0] = 0x1B;

            for (int i = 1; i < 48; i++)

                ntpDataSend[i] = 0;

            mySocket.SendTo(ntpDataSend, DestinationEndPoint);


        while (mySocket.Poll(5000000, SelectMode.SelectRead))
        {

            Debug.Print("received");
        if (mySocket.Available > 0)
        {
        byte[] inBuf = new byte[mySocket.Available];
        EndPoint recEndPoint = new IPEndPoint(IPAddress.Any, 0);
        mySocket.ReceiveFrom(inBuf, ref recEndPoint);
        if (!recEndPoint.Equals(DestinationEndPoint))// Check if the received packet is from the 192.168.0.2
        continue;
        Debug.Print(new String(Encoding.UTF8.GetChars(inBuf)));
        }
        }
        }



        ////s.Bind(ServerEndPoint);
        ////Debug.Print("bound to port 2000");


        //byte[] ntpDataSend = new byte[48]; // RFC 2030

        //ntpDataSend[0] = 0x1B;

        //for (int i = 1; i < 48; i++)

        //    ntpDataSend[i] = 0;

        


        //mySocket.SendTo(ntpDataSend, ntpDataSend.Length, SocketFlags.None, DestinationEndPoint);

        //mySocket.Bind(MyServiceEndPoint);
        //mySocket.Listen(1);

        //byte[] ntpData = new byte[48]; // RFC 2030

        //Debug.Print("Listening ...");

        //// here we wait 2000 seconds for a response.
        //while (mySocket.Poll(50000000, SelectMode.SelectRead))
        //{
        //    if (mySocket.Available > 0)
        //    {
        //        ntpData = new byte[mySocket.Available];
        //        //Debug.Print("available bytes = " + mySocket.Available);

        //        EndPoint recEndPoint = new IPEndPoint(IPAddress.Any, 0);
        //        mySocket.ReceiveFrom(ntpData, ref recEndPoint);
        //        if (!recEndPoint.Equals(DestinationEndPoint))// Check if the received packet is
        //            continue;
        //        //Debug.Print("we got a response!"); //new String(Encoding.UTF8.GetChars(inBuf)));
        //    }
        //        //Debug.Print("nothing available");
        //}


        ////Debug.Print("receiving data...");

        //Debug.Print("listened!");

        //mySocket.Close();


        //byte offsetTransmitTime = 40;
        //ulong intpart = 0;
        //ulong fractpart = 0;

        //for (int i = 0; i <= 3; i++)
        //    intpart = 256 * intpart + ntpData[offsetTransmitTime + i];



        //for (int i = 4; i <= 7; i++)
        //    fractpart = 256 * fractpart + ntpData[offsetTransmitTime + i];


        //ulong milliseconds = (intpart * 1000 + (fractpart * 1000) / 0x100000000L);

        

        //TimeSpan timeSpan = TimeSpan.FromTicks((long)milliseconds * TimeSpan.TicksPerMillisecond);
        DateTime dateTime = new DateTime(1900, 1, 1);
        //dateTime += timeSpan;

        DateTime networkDateTime = dateTime.AddHours(2);//Change to my time zone
        ////Debug.Print(networkDateTime.ToString());

        return networkDateTime;
    }
}

