

// voorbeeld template klasse. De k8000 is beschikbaar via het k8000() object.
class CmdTemplate : SwitchButton
{
    // constructor. moet verplicht de createPermanentInstance() methode opnemen.
    public CmdTemplate(int inputChannel)
    {
        createPermanentInstance(this, inputChannel);
    }


    // wordt uitgevoerd als er een knop wordt ingedrukt
    public override void buttonDown() {}

    // wordt uitgevoerd als er een knop ingedrukt blijft (time_ms is de tijd dat de knop al ingedrukt is)
    public override void buttonPressed(int time_ms) {}

    // wordt uitgevoerd als de knop NIET ingedrukt is
    public override void buttonUnpressed() {}

    // wordt uitgevoerd als de knop losgelaten wordt
    public override void buttonUp() { }

    // wordt elke cyclus uitgevoerd
    public override void buttonCycle() { }
}

